ExtensionAdapter (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.taskdefs.optional.extension, class: ExtensionAdapter

# Class ExtensionAdapter

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.taskdefs.optional.extension.ExtensionAdapter

All Implemented Interfaces:
  `Cloneable`

public class ExtensionAdapter extends DataType
Simple class that represents an Extension and conforms to Ants patterns.

- ## Field Summary

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ExtensionAdapter()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `setExtensionName(String extensionName)`
  Set the name of extension.
  `void`
  `setImplementationUrl(String implementationURL)`
  Set the implementationURL of extension.
  `void`
  `setImplementationVendor(String implementationVendor)`
  Set the implementationVendor of extension.
  `void`
  `setImplementationVendorId(String implementationVendorID)`
  Set the implementationVendorID of extension.
  `void`
  `setImplementationVersion(String implementationVersion)`
  Set the implementationVersion of extension.
  `void`
  `setRefid(Reference reference)`
  Makes this instance in effect a reference to another ExtensionAdapter instance.
  `void`
  `setSpecificationVendor(String specificationVendor)`
  Set the specificationVendor of extension.
  `void`
  `setSpecificationVersion(String specificationVersion)`
  Set the specificationVersion of extension.
  `String`
  `toString()`
  a debug toString method.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, clone, dieOnCircularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `Object`
  `clone()`
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Stack<Object> stack, Project project)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ExtensionAdapter

    public ExtensionAdapter()

- ## Method Details

  - ### setExtensionName

    public void setExtensionName(String extensionName)
    Set the name of extension.
    Parameters:
      `extensionName` - the name of extension

  - ### setSpecificationVersion

    public void setSpecificationVersion(String specificationVersion)
    Set the specificationVersion of extension.
    Parameters:
      `specificationVersion` - the specificationVersion of extension

  - ### setSpecificationVendor

    public void setSpecificationVendor(String specificationVendor)
    Set the specificationVendor of extension.
    Parameters:
      `specificationVendor` - the specificationVendor of extension

  - ### setImplementationVendorId

    public void setImplementationVendorId(String implementationVendorID)
    Set the implementationVendorID of extension.
    Parameters:
      `implementationVendorID` - the implementationVendorID of extension

  - ### setImplementationVendor

    public void setImplementationVendor(String implementationVendor)
    Set the implementationVendor of extension.
    Parameters:
      `implementationVendor` - the implementationVendor of extension

  - ### setImplementationVersion

    public void setImplementationVersion(String implementationVersion)
    Set the implementationVersion of extension.
    Parameters:
      `implementationVersion` - the implementationVersion of extension

  - ### setImplementationUrl

    public void setImplementationUrl(String implementationURL)
    Set the implementationURL of extension.
    Parameters:
      `implementationURL` - the implementationURL of extension

  - ### setRefid

    public void setRefid(Reference reference) throws BuildException
    Makes this instance in effect a reference to another ExtensionAdapter instance.

    You must not set another attribute or nest elements inside this element if you make it a reference.

    Overrides:
      `setRefid` in class `DataType`
    Parameters:
      `reference` - the reference to which this instance is associated
    Throws:
      `BuildException` - if this instance already has been configured.

  - ### toString

    public String toString()
    a debug toString method.
    Overrides:
      `toString` in class `DataType`
    Returns:
      the extension in a string.
    See Also:
      - `Object.toString()`